import org.codehaus.groovy.grails.commons.ConfigurationHolder
import org.apache.commons.logging.LogFactory

class GparsGrailsPlugin {
    // the plugin version
    def version = "0.1"
    // the version or versions of Grails the plugin is designed for
    def grailsVersion = "1.1.1 > *"
    // the other plugins this plugin depends on
    def dependsOn = [:]
    // resources that are excluded from plugin packaging
    def pluginExcludes = [
            "grails-app/views/error.gsp"
    ]

    def author = "Vaclav Pech"
    def authorEmail = "vaclav@vaclavpech.eu"
    def title = "GPars Plugin"
    def description = '''\\
Adds GPars jar files to the projects. More on GPars at http://gpars.codehaus.org/
'''

    // URL to the plugin's documentation
    def documentation = "http://grails.org/GPars+Plugin"

    def doWithSpring = { detectPoolSize() }

    def onConfigChange = {event -> detectPoolSize() }

    private def detectPoolSize() {
        final String poolSize = ConfigurationHolder.config.gpars?.poolsize
        final def log = LogFactory.getLog(this.getClass())
        if ((poolSize.size()>0) && ('{}'!=poolSize.toString())) {
            log.info "[GPars] Setting gpars pool size to ${poolSize} as specified in the configuration"
            System.setProperty 'gpars.poolsize', poolSize
        } else {
            if (System.properties['gpars.poolsize']) log.info "[GPars] Using the gpars pool size of $poolSize as specified in the system properties"
            else {
                log.info "[GPars] Using the default gpars pool size since no explicit configuration has been found"
            }
        }
    }
}
